image: docker:19.03.1

variables:
  DOCKER_TLS_CERTDIR: ""

stages:
  - build
  - deploy

build_image:
  stage: build
  variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build --pull -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
  only:
    - master


deploy_testing:
  stage: deploy
  variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    DOCKER_HOST: ssh://ubuntu@$TESTING_HOST
    URLS: $CI_PROJECT_TITLE.$CI_ENVIRONMENT_SLUG.magnesium.coop
  environment:
    name: test
    url: https://$CI_PROJECT_TITLE.$TESTING_HOST
  before_script:
    - apk update
    - apk add openssh
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "$SSH_TESTING_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - URL_LIST=$URLS DOCKER_IMAGE=$CI_REGISTRY_IMAGE DOCKER_TAG=$CI_COMMIT_SHORT_SHA DOCKER_STACK=$CI_PROJECT_TITLE DEPLOY_ENV=$CI_ENVIRONMENT_SLUG docker stack deploy --with-registry-auth -c docker-compose.$CI_ENVIRONMENT_SLUG.yml $CI_PROJECT_TITLE
  only:
    - master

deploy_prod_HORASMG:
  stage: deploy
  variables:
    CLIENTE: MG
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    DOCKER_HOST: ssh://docker@$PRODUCTION_HOST
  before_script:
    - apk update
    - apk add openssh
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "$SSH_PRODUCTION_PEM_PRIVATE_KEY" > /tmp/key.pem && chmod 600 /tmp/key.pem
    - ssh-add /tmp/key.pem
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - sed -i "s/REPLACE_CLIENTE/$CLIENTE/g" docker-compose.prod.yml
  script:
    - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY
    - URL_API=$URL_API_MG URL_ICO=$URL_ICO_MG URL_LIST=$URL_MG DOCKER_IMAGE=$CI_REGISTRY_IMAGE DOCKER_TAG=$CI_COMMIT_SHORT_SHA DOCKER_STACK=$CI_PROJECT_TITLE-$CLIENTE DEPLOY_ENV=$CI_ENVIRONMENT_SLUG docker stack deploy --with-registry-auth -c docker-compose.$CI_ENVIRONMENT_SLUG.yml $CI_PROJECT_TITLE-$CLIENTE
  environment:
    name: prod
    url: $CI_PROJECT_TITLE-$CLIENTE.$CI_ENVIRONMENT_SLUG.magnesium.coop
  when: manual
  only:
    - master


deploy_prod_MARQ:
  stage: deploy
  variables:
    CLIENTE: MARQ
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    DOCKER_HOST: ssh://docker@$PRODUCTION_HOST
  before_script:
    - apk update
    - apk add openssh
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "$SSH_PRODUCTION_PEM_PRIVATE_KEY" > /tmp/key.pem && chmod 600 /tmp/key.pem
    - ssh-add /tmp/key.pem
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - sed -i "s/REPLACE_CLIENTE/$CLIENTE/g" docker-compose.prod.yml
  script:
    - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY
    - URL_API=$URL_API_MARQ URL_ICO=$URL_ICO_MARQ URL_LIST=$URL_MARQ DOCKER_IMAGE=$CI_REGISTRY_IMAGE DOCKER_TAG=$CI_COMMIT_SHORT_SHA DOCKER_STACK=$CI_PROJECT_TITLE-$CLIENTE DEPLOY_ENV=$CI_ENVIRONMENT_SLUG docker stack deploy --with-registry-auth -c docker-compose.$CI_ENVIRONMENT_SLUG.yml $CI_PROJECT_TITLE-$CLIENTE
  environment:
    name: prod
    url: $CI_PROJECT_TITLE-$CLIENTE.$CI_ENVIRONMENT_SLUG.magnesium.coop
  when: manual
  only:
    - master

deploy_prod_MAG:
  stage: deploy
  variables:
    CLIENTE: MAG
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    DOCKER_HOST: ssh://docker@$PRODUCTION_HOST
  before_script:
    - apk update
    - apk add openssh
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "$SSH_PRODUCTION_PEM_PRIVATE_KEY" > /tmp/key.pem && chmod 600 /tmp/key.pem
    - ssh-add /tmp/key.pem
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - sed -i "s/REPLACE_CLIENTE/$CLIENTE/g" docker-compose.prod.yml
  script:
    - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY
    - URL_API=$URL_API_MAG URL_ICO=$URL_ICO_MAG URL_LIST=$URL_MAG DOCKER_IMAGE=$CI_REGISTRY_IMAGE DOCKER_TAG=$CI_COMMIT_SHORT_SHA DOCKER_STACK=$CI_PROJECT_TITLE-$CLIENTE DEPLOY_ENV=$CI_ENVIRONMENT_SLUG docker stack deploy --with-registry-auth -c docker-compose.$CI_ENVIRONMENT_SLUG.yml $CI_PROJECT_TITLE-$CLIENTE
  environment:
    name: prod
    url: $CI_PROJECT_TITLE-$CLIENTE.$CI_ENVIRONMENT_SLUG.magnesium.coop
  when: manual
  only:
    - master
